Index: src/Actions/AtomAction/ChangeElementAction.hpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/ChangeElementAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * ChangeElementAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef CHANGELEMENTACTION_HPP_
+#define CHANGELEMENTACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AtomChangeElementAction : public Action {
+public:
+  AtomChangeElementAction();
+  virtual ~AtomChangeElementAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* CHANGELEMENTACTION_HPP_ */
Index: src/Actions/AtomAction/RemoveAction.cpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/RemoveAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,76 @@
+/*
+ * RemoveAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AtomAction/RemoveAction.hpp"
+#include "CommandLineParser.hpp"
+#include "atom.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AtomRemoveAction::NAME[] = "remove-atom";
+
+AtomRemoveAction::AtomRemoveAction() :
+  Action(NAME)
+{}
+
+AtomRemoveAction::~AtomRemoveAction()
+{}
+
+Action::state_ptr AtomRemoveAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  atom *first = NULL;
+
+  dialog->queryAtom(NAME, &first, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    delete dialog;
+    DoLog(1) && (Log() << Verbose(1) << "Removing atom " << first->getId() << "." << endl);
+    World::getInstance().destroyAtom(first);
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+
+}
+
+Action::state_ptr AtomRemoveAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AtomRemoveAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AtomRemoveAction::canUndo() {
+  return false;
+}
+
+bool AtomRemoveAction::shouldUndo() {
+  return false;
+}
+
+const string AtomRemoveAction::getName() {
+  return NAME;
+}
Index: src/Actions/AtomAction/RemoveAction.hpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/RemoveAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * RemoveAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef REMOVEACTION_HPP_
+#define REMOVEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AtomRemoveAction : public Action {
+public:
+  AtomRemoveAction();
+  virtual ~AtomRemoveAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* REMOVEACTION_HPP_ */
Index: src/Actions/CmdAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CmdAction/BondLengthTableAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/BondLengthTableAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,86 @@
+/*
+ * BondLengthTableAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/BondLengthTableAction.hpp"
+#include "CommandLineParser.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineBondLengthTableAction::NAME[] = "bond-table";
+
+CommandLineBondLengthTableAction::CommandLineBondLengthTableAction() :
+  Action(NAME)
+{}
+
+CommandLineBondLengthTableAction::~CommandLineBondLengthTableAction()
+{}
+
+Action::state_ptr CommandLineBondLengthTableAction::performCall() {
+  ostringstream usage;
+  string BondGraphFileName;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  config *configuration = World::getInstance().getConfig();
+  dialog->queryString(NAME, &BondGraphFileName, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    delete dialog;
+  } else {
+    delete dialog;
+  }
+
+  if (configuration->BG == NULL) {
+    configuration->BG = new BondGraph(configuration->GetIsAngstroem());
+    if ((!BondGraphFileName.empty()) && (configuration->BG->LoadBondLengthTable(BondGraphFileName))) {
+      DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
+      return Action::success;
+    } else {
+      DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
+      return Action::failure;
+    }
+  } else {
+    DoLog(0) && (Log() << Verbose(0) << "Bond length table already present." << endl);
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineBondLengthTableAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineBondLengthTableAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineBondLengthTableAction::canUndo() {
+  return false;
+}
+
+bool CommandLineBondLengthTableAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineBondLengthTableAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/BondLengthTableAction.hpp
===================================================================
--- src/Actions/CmdAction/BondLengthTableAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/BondLengthTableAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * BondLengthTableAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef BONDLENGTHTABLEACTION_HPP_
+#define BONDLENGTHTABLEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineBondLengthTableAction : public Action {
+public:
+  CommandLineBondLengthTableAction();
+  virtual ~CommandLineBondLengthTableAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* BONDLENGTHTABLEACTION_HPP_ */
Index: src/Actions/CmdAction/ElementDbAction.cpp
===================================================================
--- src/Actions/CmdAction/ElementDbAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/ElementDbAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,88 @@
+/*
+ * ElementDbAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/ElementDbAction.hpp"
+#include "CommandLineParser.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "periodentafel.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineElementDbAction::NAME[] = "element-db";
+
+CommandLineElementDbAction::CommandLineElementDbAction() :
+  Action(NAME)
+{}
+
+CommandLineElementDbAction::~CommandLineElementDbAction()
+{}
+
+Action::state_ptr CommandLineElementDbAction::performCall() {
+  ostringstream usage;
+  string databasepath;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  // get the path
+  // TODO: Make databasepath a std::string
+  config *configuration = World::getInstance().getConfig();
+  dialog->queryString(NAME, &databasepath, MapOfActions::getInstance().getDescription(NAME));
+  strcpy(configuration->databasepath, databasepath.c_str());
+
+  if(dialog->display()) {
+    delete dialog;
+  } else {
+    delete dialog;
+  }
+
+  // load table
+  periodentafel *periode = World::getInstance().getPeriode();
+  if (periode->LoadPeriodentafel(configuration->databasepath)) {
+    DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
+    //periode->Output();
+    return Action::success;
+  } else {
+    DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
+    return Action::failure;
+  }
+
+}
+
+Action::state_ptr CommandLineElementDbAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineElementDbAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineElementDbAction::canUndo() {
+  return false;
+}
+
+bool CommandLineElementDbAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineElementDbAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/ElementDbAction.hpp
===================================================================
--- src/Actions/CmdAction/ElementDbAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/ElementDbAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * ElementDbAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ELEMENTDBACTION_HPP_
+#define ELEMENTDBACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineElementDbAction : public Action {
+public:
+  CommandLineElementDbAction();
+  virtual ~CommandLineElementDbAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ELEMENTDBACTION_HPP_ */
Index: src/Actions/CmdAction/FastParsingAction.cpp
===================================================================
--- src/Actions/CmdAction/FastParsingAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/FastParsingAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,76 @@
+/*
+ * FastParsingAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/FastParsingAction.hpp"
+#include "CommandLineParser.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineFastParsingAction::NAME[] = "fastparsing";
+
+CommandLineFastParsingAction::CommandLineFastParsingAction() :
+  Action(NAME)
+{}
+
+CommandLineFastParsingAction::~CommandLineFastParsingAction()
+{}
+
+Action::state_ptr CommandLineFastParsingAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  config *configuration = World::getInstance().getConfig();
+  dialog->queryBoolean(NAME, &configuration->FastParsing, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    if (configuration->FastParsing)
+      DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+    else
+      DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineFastParsingAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineFastParsingAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineFastParsingAction::canUndo() {
+  return false;
+}
+
+bool CommandLineFastParsingAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineFastParsingAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/FastParsingAction.hpp
===================================================================
--- src/Actions/CmdAction/FastParsingAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/FastParsingAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * FastParsingAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef FASTPARSINGACTION_HPP_
+#define FASTPARSINGACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineFastParsingAction : public Action {
+public:
+  CommandLineFastParsingAction();
+  virtual ~CommandLineFastParsingAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* FASTPARSINGACTION_HPP_ */
Index: src/Actions/CmdAction/HelpAction.cpp
===================================================================
--- src/Actions/CmdAction/HelpAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/HelpAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,69 @@
+/*
+ * HelpAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/HelpAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineHelpAction::NAME[] = "help";
+
+CommandLineHelpAction::CommandLineHelpAction() :
+  Action(NAME)
+{}
+
+CommandLineHelpAction::~CommandLineHelpAction()
+{}
+
+Action::state_ptr CommandLineHelpAction::performCall() {
+  ostringstream usage;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  usage << CommandLineParser::getInstance().visible << endl;
+  dialog->queryEmpty(NAME, usage.str());
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineHelpAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineHelpAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineHelpAction::canUndo() {
+  return false;
+}
+
+bool CommandLineHelpAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineHelpAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/HelpAction.hpp
===================================================================
--- src/Actions/CmdAction/HelpAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/HelpAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * HelpAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef HELPACTION_HPP_
+#define HELPACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineHelpAction : public Action {
+public:
+  CommandLineHelpAction();
+  virtual ~CommandLineHelpAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* HELPACTION_HPP_ */
Index: src/Actions/CmdAction/VerboseAction.cpp
===================================================================
--- src/Actions/CmdAction/VerboseAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/VerboseAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,72 @@
+/*
+ * VerboseAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/VerboseAction.hpp"
+#include "CommandLineParser.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineVerboseAction::NAME[] = "verbose";
+
+CommandLineVerboseAction::CommandLineVerboseAction() :
+  Action(NAME)
+{}
+
+CommandLineVerboseAction::~CommandLineVerboseAction()
+{}
+
+Action::state_ptr CommandLineVerboseAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  int verbosity = 2;
+
+  dialog->queryInt(NAME, &verbosity, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    setVerbosity(verbosity);
+    DoLog(0) && (Log() << Verbose(0) << "Setting verbosity to " << verbosity << "." << endl);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineVerboseAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineVerboseAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineVerboseAction::canUndo() {
+  return false;
+}
+
+bool CommandLineVerboseAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineVerboseAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/VerboseAction.hpp
===================================================================
--- src/Actions/CmdAction/VerboseAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/VerboseAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * VerboseAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef VERBOSEACTION_HPP_
+#define VERBOSEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineVerboseAction : public Action {
+public:
+  CommandLineVerboseAction();
+  virtual ~CommandLineVerboseAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* VERBOSEACTION_HPP_ */
Index: src/Actions/CmdAction/VersionAction.cpp
===================================================================
--- src/Actions/CmdAction/VersionAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/VersionAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,67 @@
+/*
+ * VersionAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/VersionAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char CommandLineVersionAction::NAME[] = "version";
+
+CommandLineVersionAction::CommandLineVersionAction() :
+  Action(NAME)
+{}
+
+CommandLineVersionAction::~CommandLineVersionAction()
+{}
+
+Action::state_ptr CommandLineVersionAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryEmpty(NAME, ESPACKVersion);
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineVersionAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineVersionAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineVersionAction::canUndo() {
+  return false;
+}
+
+bool CommandLineVersionAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineVersionAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/VersionAction.hpp
===================================================================
--- src/Actions/CmdAction/VersionAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/CmdAction/VersionAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,31 @@
+/*
+ * VersionAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef VERSIONACTION_HPP_
+#define VERSIONACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "version.h"
+
+class CommandLineVersionAction : public Action {
+public:
+  CommandLineVersionAction();
+  virtual ~CommandLineVersionAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* VERSIONACTION_HPP_ */
Index: src/Actions/FragmentationAction/DepthFirstSearchAction.cpp
===================================================================
--- src/Actions/FragmentationAction/DepthFirstSearchAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/FragmentationAction/DepthFirstSearchAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,105 @@
+/*
+ * DepthFirstSearchAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/FragmentationAction/DepthFirstSearchAction.hpp"
+#include "CommandLineParser.hpp"
+#include "atom.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "Descriptors/MoleculeIdDescriptor.hpp"
+#include "stackclass.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char FragmentationDepthFirstSearchAction::NAME[] = "depth-first-search";
+
+FragmentationDepthFirstSearchAction::FragmentationDepthFirstSearchAction() :
+  Action(NAME)
+{}
+
+FragmentationDepthFirstSearchAction::~FragmentationDepthFirstSearchAction()
+{}
+
+Action::state_ptr FragmentationDepthFirstSearchAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  double distance;
+
+  dialog->queryDouble(NAME, &distance, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Depth-First-Search Analysis." << endl);
+    molecule * const mol = World::getInstance().getMolecule(MoleculeById(0));
+    MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
+    int *MinimumRingSize = new int[mol->AtomCount];
+    atom ***ListOfLocalAtoms = NULL;
+    class StackClass<bond *> *BackEdgeStack = NULL;
+    class StackClass<bond *> *LocalBackEdgeStack = NULL;
+    mol->CreateAdjacencyList(distance, World::getInstance().getConfig()->GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
+    Subgraphs = mol->DepthFirstSearchAnalysis(BackEdgeStack);
+    if (Subgraphs != NULL) {
+      int FragmentCounter = 0;
+      while (Subgraphs->next != NULL) {
+        Subgraphs = Subgraphs->next;
+        Subgraphs->FillBondStructureFromReference(mol, FragmentCounter, ListOfLocalAtoms, false);  // we want to keep the created ListOfLocalAtoms
+        LocalBackEdgeStack = new StackClass<bond *> (Subgraphs->Leaf->BondCount);
+        Subgraphs->Leaf->PickLocalBackEdges(ListOfLocalAtoms[FragmentCounter], BackEdgeStack, LocalBackEdgeStack);
+        Subgraphs->Leaf->CyclicStructureAnalysis(LocalBackEdgeStack, MinimumRingSize);
+        delete(LocalBackEdgeStack);
+        delete(Subgraphs->previous);
+        FragmentCounter++;
+      }
+      delete(Subgraphs);
+      for (int i=0;i<FragmentCounter;i++)
+        Free(&ListOfLocalAtoms[i]);
+      Free(&ListOfLocalAtoms);
+    }
+    delete(BackEdgeStack);
+    delete[](MinimumRingSize);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr FragmentationDepthFirstSearchAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr FragmentationDepthFirstSearchAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool FragmentationDepthFirstSearchAction::canUndo() {
+  return false;
+}
+
+bool FragmentationDepthFirstSearchAction::shouldUndo() {
+  return false;
+}
+
+const string FragmentationDepthFirstSearchAction::getName() {
+  return NAME;
+}
Index: src/Actions/FragmentationAction/DepthFirstSearchAction.hpp
===================================================================
--- src/Actions/FragmentationAction/DepthFirstSearchAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/FragmentationAction/DepthFirstSearchAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * DepthFirstSearchAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef DEPTHFIRSTSEARCHACTION_HPP_
+#define DEPTHFIRSTSEARCHACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class FragmentationDepthFirstSearchAction : public Action {
+public:
+  FragmentationDepthFirstSearchAction();
+  virtual ~FragmentationDepthFirstSearchAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* DEPTHFIRSTSEARCHACTION_HPP_ */
Index: src/Actions/FragmentationAction/FragmentationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/FragmentationAction/FragmentationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,74 @@
+/*
+ * FragmentationAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/FragmentationAction/FragmentationAction.hpp"
+#include "CommandLineParser.hpp"
+#include "atom.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "stackclass.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char FragmentationFragmentationAction::NAME[] = "subspace-dissect";
+
+FragmentationFragmentationAction::FragmentationFragmentationAction() :
+  Action(NAME)
+{}
+
+FragmentationFragmentationAction::~FragmentationFragmentationAction()
+{}
+
+Action::state_ptr FragmentationFragmentationAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr FragmentationFragmentationAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr FragmentationFragmentationAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool FragmentationFragmentationAction::canUndo() {
+  return false;
+}
+
+bool FragmentationFragmentationAction::shouldUndo() {
+  return false;
+}
+
+const string FragmentationFragmentationAction::getName() {
+  return NAME;
+}
